Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 2528)
@@ -4,13 +4,14 @@
    !! Ocean dynamics:  hydrostatic pressure gradient trend
    !!======================================================================
-   !! History :  1.0  !  87-09  (P. Andrich, M.-A. Foujols)  hpg_zco: Original code
-   !!            5.0  !  91-11  (G. Madec)
-   !!            7.0  !  96-01  (G. Madec)  hpg_sco: Original code for s-coordinates
-   !!            8.0  !  97-05  (G. Madec)  split dynber into dynkeg and dynhpg
-   !!            8.5  !  02-07  (G. Madec)  F90: Free form and module
-   !!            8.5  !  02-08  (A. Bozec)  hpg_zps: Original code
-   !!            9.0  !  05-10  (A. Beckmann, B.W. An)  various s-coordinate options
-   !!                           Original code for hpg_ctl, hpg_hel hpg_wdj, hpg_djc, hpg_rot 
-   !!            9.0  !  05-11  (G. Madec) style & small optimisation
+   !! History :  OPA  !  1987-09  (P. Andrich, M.-A. Foujols)  hpg_zco: Original code
+   !!            5.0  !  1991-11  (G. Madec)
+   !!            7.0  !  1996-01  (G. Madec)  hpg_sco: Original code for s-coordinates
+   !!            8.0  !  1997-05  (G. Madec)  split dynber into dynkeg and dynhpg
+   !!            8.5  !  2002-07  (G. Madec)  F90: Free form and module
+   !!            8.5  !  2002-08  (A. Bozec)  hpg_zps: Original code
+   !!   NEMO     1.0  !  2005-10  (A. Beckmann, B.W. An)  various s-coordinate options
+   !!                 !         Original code for hpg_ctl, hpg_hel hpg_wdj, hpg_djc, hpg_rot 
+   !!             -   !  2005-11  (G. Madec) style & small optimisation
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
@@ -18,5 +19,5 @@
    !!   dyn_hpg      : update the momentum trend with the now horizontal
    !!                  gradient of the hydrostatic pressure
-   !!       hpg_ctl  : initialisation and control of options
+   !!   dyn_hpg_init : initialisation and control of options
    !!       hpg_zco  : z-coordinate scheme
    !!       hpg_zps  : z-coordinate plus partial steps (interpolation)
@@ -39,5 +40,6 @@
    PRIVATE
 
-   PUBLIC   dyn_hpg    ! routine called by step module
+   PUBLIC   dyn_hpg        ! routine called by step module
+   PUBLIC   dyn_hpg_init   ! routine called by opa module
 
    !                                              !!* Namelist namdyn_hpg : hydrostatic pressure gradient 
@@ -49,5 +51,5 @@
    LOGICAL , PUBLIC ::   ln_hpg_djc    = .FALSE.   !: s-coordinate (Density Jacobian with Cubic polynomial)
    LOGICAL , PUBLIC ::   ln_hpg_rot    = .FALSE.   !: s-coordinate (ROTated axes scheme)
-   REAL(wp), PUBLIC ::   rn_gamma      = 0.e0      !: weighting coefficient
+   REAL(wp), PUBLIC ::   rn_gamma      = 0._wp     !: weighting coefficient
    LOGICAL , PUBLIC ::   ln_dynhpg_imp = .FALSE.   !: semi-implicite hpg flag
 
@@ -58,9 +60,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -79,12 +80,10 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdu, ztrdv   ! 3D temporary workspace
       !!----------------------------------------------------------------------
-   
-      IF( kt == nit000 )   CALL hpg_ctl      ! initialisation & control of options
-
+      !
       IF( l_trddyn ) THEN                    ! Temporary saving of ua and va trends (l_trddyn)
          ztrdu(:,:,:) = ua(:,:,:)  
          ztrdv(:,:,:) = va(:,:,:) 
       ENDIF      
-
+      !
       SELECT CASE ( nhpg )      ! Hydrastatic pressure gradient computation
       CASE (  0 )   ;   CALL hpg_zco    ( kt )      ! z-coordinate
@@ -96,5 +95,5 @@
       CASE (  6 )   ;   CALL hpg_rot    ( kt )      ! s-coordinate (ROTated axes scheme)
       END SELECT
-
+      !
       IF( l_trddyn ) THEN      ! save the hydrostatic pressure gradient trends for momentum trend diagnostics
          ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
@@ -109,7 +108,7 @@
 
 
-   SUBROUTINE hpg_ctl
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE hpg_ctl  ***
+   SUBROUTINE dyn_hpg_init
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE dyn_hpg_init  ***
       !!
       !! ** Purpose :   initializations for the hydrostatic pressure gradient
@@ -121,16 +120,15 @@
       INTEGER ::   ioptio = 0      ! temporary integer
       !!
-!     NAMELIST/namdyn_hpg/ ln_hpg_zco   , ln_hpg_zps   , ln_hpg_sco, ln_hpg_hel,   &
-!        &                 ln_hpg_wdj   , ln_hpg_djc   , ln_hpg_rot, rn_gamma  ,   &
-!        &                 ln_dynhpg_imp
-      !!----------------------------------------------------------------------
-
-!     REWIND ( numnam )               ! Namelist namdyn_hpg : already read in opa.F90 module
-!     READ   ( numnam, namdyn_hpg )
-
-      IF(lwp) THEN                    ! Control print
+      NAMELIST/namdyn_hpg/ ln_hpg_zco, ln_hpg_zps, ln_hpg_sco, ln_hpg_hel,    &
+         &                 ln_hpg_wdj, ln_hpg_djc, ln_hpg_rot, rn_gamma  , ln_dynhpg_imp
+      !!----------------------------------------------------------------------
+      !
+      REWIND( numnam )               ! Read Namelist namdyn_hpg
+      READ  ( numnam, namdyn_hpg )
+      !
+      IF(lwp) THEN                   ! Control print
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn_hpg : hydrostatic pressure gradient'
-         WRITE(numout,*) '~~~~~~~'
+         WRITE(numout,*) 'dyn_hpg_init : hydrostatic pressure gradient initialisation'
+         WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namdyn_hpg : choice of hpg scheme'
          WRITE(numout,*) '      z-coord. - full steps                             ln_hpg_zco    = ', ln_hpg_zco
@@ -144,9 +142,8 @@
          WRITE(numout,*) '      time stepping: centered (F) or semi-implicit (T)  ln_dynhpg_imp = ', ln_dynhpg_imp
       ENDIF
-
-      IF( lk_vvl .AND. .NOT. ln_hpg_sco )   THEN
-         CALL ctl_stop( 'hpg_ctl : variable volume key_vvl compatible only with the standard jacobian formulation hpg_sco')
-      ENDIF
-
+      !
+      IF( lk_vvl .AND. .NOT. ln_hpg_sco )   &
+         &   CALL ctl_stop( 'dyn_hpg_init : variable volume key_vvl require the standard jacobian formulation hpg_sco')
+      !
       !                               ! Set nhpg from ln_hpg_... flags
       IF( ln_hpg_zco )   nhpg = 0
@@ -157,5 +154,5 @@
       IF( ln_hpg_djc )   nhpg = 5
       IF( ln_hpg_rot )   nhpg = 6
-
+      !
       !                               ! Consitency check
       ioptio = 0 
@@ -168,7 +165,6 @@
       IF( ln_hpg_rot )   ioptio = ioptio + 1
       IF ( ioptio /= 1 )   CALL ctl_stop( ' NO or several hydrostatic pressure gradient options used' )
-
-      !
-   END SUBROUTINE hpg_ctl
+      !
+   END SUBROUTINE dyn_hpg_init
 
 
@@ -205,5 +201,5 @@
       
       ! Local constant initialization 
-      zcoef0 = - grav * 0.5
+      zcoef0 = - grav * 0.5_wp
 
       ! Surface value
@@ -268,7 +264,7 @@
 
       ! Local constant initialization
-      zcoef0 = - grav * 0.5
-
-      !  Surface value
+      zcoef0 = - grav * 0.5_wp
+
+      !  Surface value (also valid in partial step case)
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -303,5 +299,5 @@
       END DO
 
-      ! partial steps correction at the last level  (new gradient with  intgrd.F)
+      ! partial steps correction at the last level  (use gru & grv computed in zpshde.F90)
 # if defined key_vectopt_loop
          jj = 1
@@ -311,27 +307,19 @@
          DO ji = 2, jpim1
 # endif
-            iku = MIN ( mbathy(ji,jj), mbathy(ji+1,jj) ) - 1
-            ikv = MIN ( mbathy(ji,jj), mbathy(ji,jj+1) ) - 1
+            iku = mbku(ji,jj)
+            ikv = mbkv(ji,jj)
             zcoef2 = zcoef0 * MIN( fse3w(ji,jj,iku), fse3w(ji+1,jj  ,iku) )
             zcoef3 = zcoef0 * MIN( fse3w(ji,jj,ikv), fse3w(ji  ,jj+1,ikv) )
-            ! on i-direction
-            IF ( iku > 2 ) THEN
-               ! subtract old value
-               ua(ji,jj,iku) = ua(ji,jj,iku) - zhpi(ji,jj,iku)
-               ! compute the new one
-               zhpi (ji,jj,iku) = zhpi(ji,jj,iku-1)   &
-                  + zcoef2 * ( rhd(ji+1,jj,iku-1) - rhd(ji,jj,iku-1) + gru(ji,jj) ) / e1u(ji,jj)
-               ! add the new one to the general momentum trend
-               ua(ji,jj,iku) = ua(ji,jj,iku) + zhpi(ji,jj,iku)
+            IF( iku > 1 ) THEN            ! on i-direction (level 2 or more)
+               ua  (ji,jj,iku) = ua(ji,jj,iku) - zhpi(ji,jj,iku)         ! subtract old value
+               zhpi(ji,jj,iku) = zhpi(ji,jj,iku-1)                   &   ! compute the new one
+                  &            + zcoef2 * ( rhd(ji+1,jj,iku-1) - rhd(ji,jj,iku-1) + gru(ji,jj) ) / e1u(ji,jj)
+               ua  (ji,jj,iku) = ua(ji,jj,iku) + zhpi(ji,jj,iku)         ! add the new one to the general momentum trend
             ENDIF
-            ! on j-direction
-            IF ( ikv > 2 ) THEN
-               ! subtract old value
-               va(ji,jj,ikv) = va(ji,jj,ikv) - zhpj(ji,jj,ikv)
-               ! compute the new one
-               zhpj (ji,jj,ikv) = zhpj(ji,jj,ikv-1)   &
-                  + zcoef3 * ( rhd(ji,jj+1,ikv-1) - rhd(ji,jj,ikv-1) + grv(ji,jj) ) / e2v(ji,jj)
-               ! add the new one to the general momentum trend
-               va(ji,jj,ikv) = va(ji,jj,ikv) + zhpj(ji,jj,ikv)
+            IF( ikv > 1 ) THEN            ! on j-direction (level 2 or more)
+               va  (ji,jj,ikv) = va(ji,jj,ikv) - zhpj(ji,jj,ikv)         ! subtract old value
+               zhpj(ji,jj,ikv) = zhpj(ji,jj,ikv-1)                   &   ! compute the new one
+                  &            + zcoef3 * ( rhd(ji,jj+1,ikv-1) - rhd(ji,jj,ikv-1) + grv(ji,jj) ) / e2v(ji,jj)
+               va  (ji,jj,ikv) = va(ji,jj,ikv) + zhpj(ji,jj,ikv)         ! add the new one to the general momentum trend
             ENDIF
 # if ! defined key_vectopt_loop
@@ -377,8 +365,8 @@
 
       ! Local constant initialization
-      zcoef0 = - grav * 0.5
+      zcoef0 = - grav * 0.5_wp
       ! To use density and not density anomaly
-      IF ( lk_vvl ) THEN   ;     znad = 1.            ! Variable volume
-      ELSE                 ;     znad = 0.e0          ! Fixed volume
+      IF ( lk_vvl ) THEN   ;     znad = 1._wp          ! Variable volume
+      ELSE                 ;     znad = 0._wp         ! Fixed volume
       ENDIF
 
@@ -392,7 +380,7 @@
                &                                  - fse3w(ji  ,jj  ,1) * ( znad + rhd(ji  ,jj  ,1) ) )
             ! s-coordinate pressure gradient correction
-            zuap = -zcoef0 * ( rhd   (ji+1,jj,1) + rhd   (ji,jj,1) + 2*znad )   &
+            zuap = -zcoef0 * ( rhd   (ji+1,jj,1) + rhd   (ji,jj,1) + 2._wp * znad )   &
                &           * ( fsde3w(ji+1,jj,1) - fsde3w(ji,jj,1) ) / e1u(ji,jj)
-            zvap = -zcoef0 * ( rhd   (ji,jj+1,1) + rhd   (ji,jj,1) + 2*znad )   &
+            zvap = -zcoef0 * ( rhd   (ji,jj+1,1) + rhd   (ji,jj,1) + 2._wp * znad )   &
                &           * ( fsde3w(ji,jj+1,1) - fsde3w(ji,jj,1) ) / e2v(ji,jj)
             ! add to the general momentum trend
@@ -414,7 +402,7 @@
                   &              - fse3w(ji,jj  ,jk) * ( rhd(ji,jj,  jk) + rhd(ji,jj  ,jk-1) + 2*znad )  )
                ! s-coordinate pressure gradient correction
-               zuap = -zcoef0 * ( rhd   (ji+1,jj  ,jk) + rhd   (ji,jj,jk) + 2*znad )   &
+               zuap = -zcoef0 * ( rhd   (ji+1,jj  ,jk) + rhd   (ji,jj,jk) + 2._wp * znad )   &
                   &           * ( fsde3w(ji+1,jj  ,jk) - fsde3w(ji,jj,jk) ) / e1u(ji,jj)
-               zvap = -zcoef0 * ( rhd   (ji  ,jj+1,jk) + rhd   (ji,jj,jk) + 2*znad )   &
+               zvap = -zcoef0 * ( rhd   (ji  ,jj+1,jk) + rhd   (ji,jj,jk) + 2._wp * znad )   &
                   &           * ( fsde3w(ji  ,jj+1,jk) - fsde3w(ji,jj,jk) ) / e2v(ji,jj)
                ! add to the general momentum trend
@@ -463,5 +451,5 @@
 
       ! Local constant initialization
-      zcoef0 = - grav * 0.5
+      zcoef0 = - grav * 0.5_wp
  
       ! Surface value
@@ -495,7 +483,7 @@
                   &                                     -fse3t(ji  ,jj,jk-1) * rhd(ji  ,jj,jk-1) )
                zhpj(ji,jj,jk) = zhpj(ji,jj,jk-1) &
-                  &           +  zcoef0 / e2v(ji,jj) * ( fse3t(ji,jj+1,jk  ) * rhd(ji,jj+1,jk)   &
+                  &           +  zcoef0 / e2v(ji,jj) * ( fse3t(ji,jj+1,jk  ) * rhd(ji,jj+1,jk)     &
                   &                                     -fse3t(ji,jj  ,jk  ) * rhd(ji,jj,  jk)   ) &
-                  &           +  zcoef0 / e2v(ji,jj) * ( fse3t(ji,jj+1,jk-1) * rhd(ji,jj+1,jk-1) &
+                  &           +  zcoef0 / e2v(ji,jj) * ( fse3t(ji,jj+1,jk-1) * rhd(ji,jj+1,jk-1)   &
                   &                                     -fse3t(ji,jj  ,jk-1) * rhd(ji,jj,  jk-1) )
                ! s-coordinate pressure gradient correction
@@ -541,7 +529,7 @@
 
       ! Local constant initialization
-      zcoef0 = - grav * 0.5
-      zalph  = 0.5 - rn_gamma    ! weighting coefficients (alpha=0.5-rn_gamma
-      zbeta  = 0.5 + rn_gamma    !                        (beta =1-alpha=0.5+rn_gamma
+      zcoef0 = - grav * 0.5_wp
+      zalph  = 0.5_wp - rn_gamma    ! weighting coefficients (alpha=0.5-rn_gamma
+      zbeta  = 0.5_wp + rn_gamma    !                        (beta =1-alpha=0.5+rn_gamma
 
       ! Surface value (no ponderation)
@@ -626,7 +614,7 @@
 
       ! Local constant initialization
-      zcoef0 = - grav * 0.5
-      z1_10  = 1.0 / 10.0
-      z1_12  = 1.0 / 12.0
+      zcoef0 = - grav * 0.5_wp
+      z1_10  = 1._wp / 10._wp
+      z1_12  = 1._wp / 12._wp
 
       !----------------------------------------------------------------------------------------
@@ -660,48 +648,48 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               cffw = 2.0 * drhoz(ji  ,jj  ,jk) * drhoz(ji,jj,jk-1)
-
-               cffu = 2.0 * drhox(ji+1,jj  ,jk) * drhox(ji,jj,jk  )
-               cffx = 2.0 * dzx  (ji+1,jj  ,jk) * dzx  (ji,jj,jk  )
+               cffw = 2._wp * drhoz(ji  ,jj  ,jk) * drhoz(ji,jj,jk-1)
+
+               cffu = 2._wp * drhox(ji+1,jj  ,jk) * drhox(ji,jj,jk  )
+               cffx = 2._wp * dzx  (ji+1,jj  ,jk) * dzx  (ji,jj,jk  )
   
-               cffv = 2.0 * drhoy(ji  ,jj+1,jk) * drhoy(ji,jj,jk  )
-               cffy = 2.0 * dzy  (ji  ,jj+1,jk) * dzy  (ji,jj,jk  )
+               cffv = 2._wp * drhoy(ji  ,jj+1,jk) * drhoy(ji,jj,jk  )
+               cffy = 2._wp * dzy  (ji  ,jj+1,jk) * dzy  (ji,jj,jk  )
 
                IF( cffw > zep) THEN
-                  drhow(ji,jj,jk) = 2.0 *   drhoz(ji,jj,jk) * drhoz(ji,jj,jk-1)   &
-                     &                  / ( drhoz(ji,jj,jk) + drhoz(ji,jj,jk-1) )
+                  drhow(ji,jj,jk) = 2._wp *   drhoz(ji,jj,jk) * drhoz(ji,jj,jk-1)   &
+                     &                    / ( drhoz(ji,jj,jk) + drhoz(ji,jj,jk-1) )
                ELSE
-                  drhow(ji,jj,jk) = 0.e0
+                  drhow(ji,jj,jk) = 0._wp
                ENDIF
 
-               dzw(ji,jj,jk) = 2.0 *   dzz(ji,jj,jk) * dzz(ji,jj,jk-1)   &
-                  &                / ( dzz(ji,jj,jk) + dzz(ji,jj,jk-1) )
+               dzw(ji,jj,jk) = 2._wp *   dzz(ji,jj,jk) * dzz(ji,jj,jk-1)   &
+                  &                  / ( dzz(ji,jj,jk) + dzz(ji,jj,jk-1) )
 
                IF( cffu > zep ) THEN
-                  drhou(ji,jj,jk) = 2.0 *   drhox(ji+1,jj,jk) * drhox(ji,jj,jk)   &
-                     &                  / ( drhox(ji+1,jj,jk) + drhox(ji,jj,jk) )
+                  drhou(ji,jj,jk) = 2._wp *   drhox(ji+1,jj,jk) * drhox(ji,jj,jk)   &
+                     &                    / ( drhox(ji+1,jj,jk) + drhox(ji,jj,jk) )
                ELSE
-                  drhou(ji,jj,jk ) = 0.e0
+                  drhou(ji,jj,jk ) = 0._wp
                ENDIF
 
                IF( cffx > zep ) THEN
-                  dzu(ji,jj,jk) = 2.0*dzx(ji+1,jj,jk)*dzx(ji,jj,jk)   &
-                     &            /(dzx(ji+1,jj,jk)+dzx(ji,jj,jk))
+                  dzu(ji,jj,jk) = 2._wp *   dzx(ji+1,jj,jk) * dzx(ji,jj,jk)   &
+                     &                  / ( dzx(ji+1,jj,jk) + dzx(ji,jj,jk) )
                ELSE
-                  dzu(ji,jj,jk) = 0.e0
+                  dzu(ji,jj,jk) = 0._wp
                ENDIF
 
                IF( cffv > zep ) THEN
-                  drhov(ji,jj,jk) = 2.0 *   drhoy(ji,jj+1,jk) * drhoy(ji,jj,jk)   &
-                     &                  / ( drhoy(ji,jj+1,jk) + drhoy(ji,jj,jk) )
+                  drhov(ji,jj,jk) = 2._wp *   drhoy(ji,jj+1,jk) * drhoy(ji,jj,jk)   &
+                     &                    / ( drhoy(ji,jj+1,jk) + drhoy(ji,jj,jk) )
                ELSE
-                  drhov(ji,jj,jk) = 0.e0
+                  drhov(ji,jj,jk) = 0._wp
                ENDIF
 
                IF( cffy > zep ) THEN
-                  dzv(ji,jj,jk) = 2.0 *   dzy(ji,jj+1,jk) * dzy(ji,jj,jk)   &
-                     &                / ( dzy(ji,jj+1,jk) + dzy(ji,jj,jk) )
+                  dzv(ji,jj,jk) = 2._wp *   dzy(ji,jj+1,jk) * dzy(ji,jj,jk)   &
+                     &                  / ( dzy(ji,jj+1,jk) + dzy(ji,jj,jk) )
                ELSE
-                  dzv(ji,jj,jk) = 0.e0
+                  dzv(ji,jj,jk) = 0._wp
                ENDIF
 
@@ -713,11 +701,11 @@
       ! apply boundary conditions at top and bottom using 5.36-5.37
       !----------------------------------------------------------------------------------
-      drhow(:,:, 1 ) = 1.5 * ( drhoz(:,:, 2 ) - drhoz(:,:,  1  ) ) - 0.5 * drhow(:,:,  2  )
-      drhou(:,:, 1 ) = 1.5 * ( drhox(:,:, 2 ) - drhox(:,:,  1  ) ) - 0.5 * drhou(:,:,  2  )
-      drhov(:,:, 1 ) = 1.5 * ( drhoy(:,:, 2 ) - drhoy(:,:,  1  ) ) - 0.5 * drhov(:,:,  2  )
-
-      drhow(:,:,jpk) = 1.5 * ( drhoz(:,:,jpk) - drhoz(:,:,jpkm1) ) - 0.5 * drhow(:,:,jpkm1)
-      drhou(:,:,jpk) = 1.5 * ( drhox(:,:,jpk) - drhox(:,:,jpkm1) ) - 0.5 * drhou(:,:,jpkm1)
-      drhov(:,:,jpk) = 1.5 * ( drhoy(:,:,jpk) - drhoy(:,:,jpkm1) ) - 0.5 * drhov(:,:,jpkm1)
+      drhow(:,:, 1 ) = 1.5_wp * ( drhoz(:,:, 2 ) - drhoz(:,:,  1  ) ) - 0.5_wp * drhow(:,:,  2  )
+      drhou(:,:, 1 ) = 1.5_wp * ( drhox(:,:, 2 ) - drhox(:,:,  1  ) ) - 0.5_wp * drhou(:,:,  2  )
+      drhov(:,:, 1 ) = 1.5_wp * ( drhoy(:,:, 2 ) - drhoy(:,:,  1  ) ) - 0.5_wp * drhov(:,:,  2  )
+
+      drhow(:,:,jpk) = 1.5_wp * ( drhoz(:,:,jpk) - drhoz(:,:,jpkm1) ) - 0.5_wp * drhow(:,:,jpkm1)
+      drhou(:,:,jpk) = 1.5_wp * ( drhox(:,:,jpk) - drhox(:,:,jpkm1) ) - 0.5_wp * drhou(:,:,jpkm1)
+      drhov(:,:,jpk) = 1.5_wp * ( drhoy(:,:,jpk) - drhoy(:,:,jpkm1) ) - 0.5_wp * drhov(:,:,jpkm1)
 
 
@@ -731,9 +719,9 @@
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
-            rho_k(ji,jj,1) = -grav * ( fse3w(ji,jj,1) - fsde3w(ji,jj,1) )            &
-               &                   * (  rhd(ji,jj,1)                                 &
-               &                     + 0.5 * ( rhd(ji,jj,2) - rhd(ji,jj,1) )         &
-               &                           * ( fse3w (ji,jj,1) - fsde3w(ji,jj,1) )   &
-               &                           / ( fsde3w(ji,jj,2) - fsde3w(ji,jj,1) )  ) 
+            rho_k(ji,jj,1) = -grav * ( fse3w(ji,jj,1) - fsde3w(ji,jj,1) )               &
+               &                   * (  rhd(ji,jj,1)                                    &
+               &                     + 0.5_wp * ( rhd(ji,jj,2) - rhd(ji,jj,1) )         &
+               &                              * ( fse3w (ji,jj,1) - fsde3w(ji,jj,1) )   &
+               &                              / ( fsde3w(ji,jj,2) - fsde3w(ji,jj,1) )  ) 
          END DO
       END DO
@@ -847,7 +835,7 @@
       !  Local constant initialization
       ! -------------------------------
-      zcoef0 = - grav * 0.5
-      zforg  = 0.95e0
-      zfrot  = 1.e0 - zforg
+      zcoef0 = - grav * 0.5_wp
+      zforg  = 0.95_wp
+      zfrot  = 1._wp - zforg
 
       ! inverse of the distance between 2 diagonal T-points (defined at F-point) (here zcoef0/distance)
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 2528)
@@ -27,7 +27,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2528)
@@ -8,6 +8,6 @@
 
    !!----------------------------------------------------------------------
-   !!   dyn_ldf     : update the dynamics trend with the lateral diffusion
-   !!   dyn_ldf_ctl : initialization, namelist read, and parameters control
+   !!   dyn_ldf      : update the dynamics trend with the lateral diffusion
+   !!   dyn_ldf_init : initialization, namelist read, and parameters control
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers
@@ -30,15 +30,16 @@
    PRIVATE
 
-   PUBLIC   dyn_ldf   ! called by step module 
-
-   INTEGER ::   nldf = 0   ! type of lateral diffusion used defined from ln_dynldf_... namlist logicals)
+   PUBLIC   dyn_ldf       ! called by step module 
+   PUBLIC   dyn_ldf_init  ! called by opa  module 
+
+   INTEGER ::   nldf = -2   ! type of lateral diffusion used defined from ln_dynldf_... namlist logicals)
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
-   !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -55,6 +56,4 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdu, ztrdv   ! 3D workspace
       !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL dyn_ldf_ctl      ! initialisation & control of options
 
       IF( l_trddyn )   THEN                      ! temporary save of ta and sa trends
@@ -69,4 +68,10 @@
       CASE ( 2 )    ;   CALL dyn_ldf_bilap  ( kt )      ! iso-level bilaplacian
       CASE ( 3 )    ;   CALL dyn_ldf_bilapg ( kt )      ! s-coord. horizontal bilaplacian
+      CASE ( 4 )                                        ! iso-level laplacian + bilaplacian
+         CALL dyn_ldf_lap    ( kt )
+         CALL dyn_ldf_bilap  ( kt )
+      CASE ( 5 )                                        ! rotated laplacian + bilaplacian (s-coord)
+         CALL dyn_ldf_iso    ( kt )
+         CALL dyn_ldf_bilapg ( kt )
       !
       CASE ( -1 )                                       ! esopa: test all possibility with control print
@@ -83,4 +88,11 @@
                         CALL prt_ctl( tab3d_1=ua, clinfo1=' ldf3 - Ua: ', mask1=umask,   &
             &                         tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+      !
+      CASE ( -2 )                                       ! neither laplacian nor bilaplacian schemes used
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'dyn_ldf : no lateral diffusion on momentum setup'
+            IF(lwp) WRITE(numout,*) '~~~~~~~ '
+         ENDIF
       END SELECT
 
@@ -97,7 +109,7 @@
 
 
-   SUBROUTINE dyn_ldf_ctl
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE dyn_ldf_ctl  ***
+   SUBROUTINE dyn_ldf_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE dyn_ldf_init  ***
       !! 
       !! ** Purpose :   initializations of the horizontal ocean dynamics physics
@@ -110,5 +122,5 @@
       IF(lwp) THEN                        ! Namelist print
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn_ldf_ctl : Choice of the lateral diffusive operator on dynamics'
+         WRITE(numout,*) 'dyn_ldf_init : Choice of the lateral diffusive operator on dynamics'
          WRITE(numout,*) '~~~~~~~~~~~'
          WRITE(numout,*) '       Namelist nam_dynldf : set lateral mixing parameters (type, direction, coefficients)'
@@ -124,5 +136,5 @@
       IF( ln_dynldf_lap   )   ioptio = ioptio + 1
       IF( ln_dynldf_bilap )   ioptio = ioptio + 1
-      IF( ioptio /= 1 ) CALL ctl_stop( '          use ONE of the 2 lap/bilap operator type on dynamics' )
+      IF( ioptio <  1 ) CALL ctl_warn( '          neither laplacian nor bilaplacian operator set for dynamics' )
       ioptio = 0
       IF( ln_dynldf_level )   ioptio = ioptio + 1
@@ -144,5 +156,5 @@
             IF ( ln_dynldf_iso   )   nldf = 1      ! isoneutral (   rotation)
          ENDIF
-         IF ( ln_sco ) THEN             ! z-coordinate
+         IF ( ln_sco ) THEN             ! s-coordinate
             IF ( ln_dynldf_level )   nldf = 0      ! iso-level  (no rotation)
             IF ( ln_dynldf_hor   )   nldf = 1      ! horizontal (   rotation)
@@ -162,5 +174,5 @@
             IF ( ln_dynldf_iso   )   ierr = 2      ! isoneutral (   rotation)
          ENDIF
-         IF ( ln_sco ) THEN             ! z-coordinate
+         IF ( ln_sco ) THEN             ! s-coordinate
             IF ( ln_dynldf_level )   nldf = 2      ! iso-level  (no rotation)
             IF ( ln_dynldf_hor   )   nldf = 3      ! horizontal (   rotation)
@@ -169,4 +181,22 @@
       ENDIF
       
+      IF( ln_dynldf_lap .AND. ln_dynldf_bilap ) THEN  ! mixed laplacian and bilaplacian operators
+         IF ( ln_zco ) THEN                ! z-coordinate
+            IF ( ln_dynldf_level )   nldf = 4      ! iso-level  (no rotation)
+            IF ( ln_dynldf_hor   )   nldf = 4      ! horizontal (no rotation)
+            IF ( ln_dynldf_iso   )   ierr = 2      ! isoneutral (   rotation)
+         ENDIF
+         IF ( ln_zps ) THEN             ! z-coordinate
+            IF ( ln_dynldf_level )   ierr = 1      ! iso-level not allowed 
+            IF ( ln_dynldf_hor   )   nldf = 4      ! horizontal (no rotation)
+            IF ( ln_dynldf_iso   )   ierr = 2      ! isoneutral (   rotation)
+         ENDIF
+         IF ( ln_sco ) THEN             ! s-coordinate
+            IF ( ln_dynldf_level )   nldf = 4      ! iso-level  (no rotation)
+            IF ( ln_dynldf_hor   )   nldf = 5      ! horizontal (   rotation)
+            IF ( ln_dynldf_iso   )   ierr = 2      ! isoneutral (   rotation)
+         ENDIF
+      ENDIF
+
       IF( lk_esopa )                 nldf = -1     ! esopa test
 
@@ -179,12 +209,15 @@
       IF(lwp) THEN
          WRITE(numout,*)
+         IF( nldf == -2 )   WRITE(numout,*) '              neither laplacian nor bilaplacian schemes used'
          IF( nldf == -1 )   WRITE(numout,*) '              ESOPA test All scheme used'
          IF( nldf ==  0 )   WRITE(numout,*) '              laplacian operator'
-         IF( nldf ==  1 )   WRITE(numout,*) '              Rotated laplacian operator'
+         IF( nldf ==  1 )   WRITE(numout,*) '              rotated laplacian operator'
          IF( nldf ==  2 )   WRITE(numout,*) '              bilaplacian operator'
-         IF( nldf ==  3 )   WRITE(numout,*) '              Rotated bilaplacian'
-      ENDIF
-      !
-   END SUBROUTINE dyn_ldf_ctl
+         IF( nldf ==  3 )   WRITE(numout,*) '              rotated bilaplacian'
+         IF( nldf ==  4 )   WRITE(numout,*) '              laplacian and bilaplacian operators'
+         IF( nldf ==  5 )   WRITE(numout,*) '              rotated laplacian and bilaplacian operators'
+      ENDIF
+      !
+   END SUBROUTINE dyn_ldf_init
 
    !!======================================================================
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 2528)
@@ -29,7 +29,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -162,9 +162,5 @@
                zuf(ji,jj,jk) = fmask(ji,jj,jk) * (  zcv(ji+1,jj  ) - zcv(ji,jj)      &
                   &                            - zcu(ji  ,jj+1) + zcu(ji,jj)  )   &
-#if defined key_zco
-                  &                         / ( e1f(ji,jj)*e2f(ji,jj) )
-#else
                   &       * fse3f(ji,jj,jk) / ( e1f(ji,jj)*e2f(ji,jj) )
-#endif
             END DO  
          END DO  
@@ -173,11 +169,6 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zlu(ji,jj,jk) = e2u(ji,jj) * zlu(ji,jj,jk)
-               zlv(ji,jj,jk) = e1v(ji,jj) * zlv(ji,jj,jk)
-#else
                zlu(ji,jj,jk) = e2u(ji,jj) * fse3u(ji,jj,jk) * zlu(ji,jj,jk)
                zlv(ji,jj,jk) = e1v(ji,jj) * fse3v(ji,jj,jk) * zlv(ji,jj,jk)
-#endif
             END DO
          END DO
@@ -186,9 +177,5 @@
          DO jj = 2, jpj
             DO ji = fs_2, jpi   ! vector opt.
-#if defined key_zco
-               zbt = e1t(ji,jj) * e2t(ji,jj)
-#else
                zbt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-#endif
                zut(ji,jj,jk) = (  zlu(ji,jj,jk) - zlu(ji-1,jj  ,jk)   &
                   &             + zlv(ji,jj,jk) - zlv(ji  ,jj-1,jk) ) / zbt
@@ -210,11 +197,6 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               ze2u = e2u(ji,jj)
-               ze2v = e1v(ji,jj)
-#else
                ze2u = e2u(ji,jj) * fse3u(ji,jj,jk)
                ze2v = e1v(ji,jj) * fse3v(ji,jj,jk)
-#endif
                ! horizontal biharmonic diffusive trends
                zua = - ( zuf(ji  ,jj,jk) - zuf(ji,jj-1,jk) ) / ze2u   &
